package be.iminds.ilabt.jfed.restapi.json;

import be.iminds.ilabt.jfed.util.GeniUrn;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import java.net.URI;
import java.sql.Timestamp;

/**
 * SpeaksForCredential
 */
public class SpeaksForCredential {
    private final String credentialXml;
    private final GeniUrn speaker;
    private final GeniUrn speakingFor;
    private final Timestamp expire;

    private final URI uri;

    @JsonCreator
    public SpeaksForCredential(@JsonProperty("credentialXml") String credentialXml,
                               @JsonProperty("speaker") GeniUrn speaker,
                               @JsonProperty("speakingFor") GeniUrn speakingFor,
                               @JsonProperty("expire") Timestamp expire,
                               @JsonProperty("uri") URI uri) {
        this.credentialXml = credentialXml;
        this.speaker = speaker;
        this.speakingFor = speakingFor;
        this.expire = expire;
        this.uri = uri;
    }

    @JsonProperty
    public String getCredentialXml() {
        return credentialXml;
    }

    @JsonProperty
    @JsonSerialize(using = JsonGeniUrnSerializer.class)
    @JsonDeserialize(using = JsonGeniUrnDeserializer.class)
    public GeniUrn getSpeaker() {
        return speaker;
    }

    @JsonProperty
    @JsonSerialize(using = JsonGeniUrnSerializer.class)
    @JsonDeserialize(using = JsonGeniUrnDeserializer.class)
    public GeniUrn getSpeakingFor() {
        return speakingFor;
    }

    @JsonProperty
    public Timestamp getExpire() {
        return expire;
    }

    @JsonProperty
    public URI getUri() {
        return uri;
    }

    @JsonProperty(value="@type")
    public String getClassName() {
        return getClass().getSimpleName();
    }

    @JsonProperty(value="@type")
    private void setClassName(String className) {
        if (!getClass().getSimpleName().equals(className))
            throw new IllegalArgumentException("@type must be "+getClass().getSimpleName());
    }
}
