package be.iminds.ilabt.jfed.restapi.json;

import be.iminds.ilabt.jfed.util.GeniUrn;

import java.net.URI;
import java.sql.Timestamp;

public class SpeaksForCredentialBuilder {
    private String credentialXml;
    private GeniUrn speaker;
    private GeniUrn speakingFor;
    private Timestamp expire;

    private URI uri;

    public SpeaksForCredentialBuilder() {

    }

    public SpeaksForCredentialBuilder(SpeaksForCredential orig) {
        this.credentialXml = orig.getCredentialXml();
        this.speaker = orig.getSpeaker();
        this.speakingFor = orig.getSpeakingFor();
        this.expire = orig.getExpire();
    }

    public SpeaksForCredentialBuilder setCredentialXml(String credentialXml) {
        this.credentialXml = credentialXml;
        return this;
    }

    public SpeaksForCredentialBuilder setSpeaker(GeniUrn speaker) {
        this.speaker = speaker;
        return this;
    }

    public SpeaksForCredentialBuilder setSpeakingFor(GeniUrn speakingFor) {
        this.speakingFor = speakingFor;
        return this;
    }

    public SpeaksForCredentialBuilder setExpire(Timestamp expire) {
        this.expire = expire;
        return this;
    }

    public SpeaksForCredentialBuilder setUri(URI uri) {
        this.uri = uri;
        return this;
    }

    public SpeaksForCredential create() {
        return new SpeaksForCredential(credentialXml, speaker, speakingFor, expire, uri);
    }


    public String getCredentialXml() { return credentialXml; }
    public GeniUrn getSpeaker() { return speaker; }
    public GeniUrn getSpeakingFor() { return speakingFor; }
    public Timestamp getExpire() { return expire; }
    public URI getUri() { return uri; }
}
