package be.iminds.ilabt.jfed.restapi.dao;

import be.iminds.ilabt.jfed.fedmon.webapi.service.json.Log;
import be.iminds.ilabt.jfed.fedmon.webapi.service.json.LogBuilder;
import be.iminds.ilabt.jfed.restapi.debugdata.ExperimentDD;
import be.iminds.ilabt.jfed.restapi.debugdata.ExperimentDDBuilder;
import com.fasterxml.jackson.databind.DeserializationFeature;
import com.fasterxml.jackson.databind.ObjectMapper;
import io.dropwizard.jackson.Jackson;
import org.skife.jdbi.v2.StatementContext;
import org.skife.jdbi.v2.tweak.ResultSetMapper;

import java.io.IOException;
import java.sql.ResultSet;
import java.sql.SQLException;

/**
 * LogMapper
 */
public class ExperimentDDMapper implements ResultSetMapper<ExperimentDDBuilder>
{
    private static final ObjectMapper MAPPER;
    static {
        MAPPER = Jackson.newObjectMapper();
        //do notbe strict on unknown properties
        MAPPER.configure(DeserializationFeature.FAIL_ON_UNKNOWN_PROPERTIES, false);
    }

    public ExperimentDDBuilder map(int index, ResultSet r, StatementContext ctx) throws SQLException
    {
        long id = r.getLong("experiment_id");
        String json = r.getString("json");

        ExperimentDD experimentDD = null;
        try {
            experimentDD = MAPPER.readValue(json, ExperimentDD.class);
        } catch (IOException e) {
            throw new SQLException("Bad JSON in DB: "+json);
        }

        if (experimentDD.getId() == null) {
            throw new SQLException("ExperimentDD for "+id+" in  DB has no ID: "+json);
        }
        if (experimentDD.getId() != id) {
            throw new SQLException("ExperimentDD for "+id+" has other id ("+experimentDD.getId()+") in JSON: "+json);
        }

        ExperimentDDBuilder res = new ExperimentDDBuilder(experimentDD);

        return res;
    }
}
